package com.example.demo;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.DependsOn;

public class ClassroomConfig {
    @Bean
    @DependsOn({"instructors","students"})
    public Classroom currentCohort(){
        Instructors instructors= new Instructors();
        Students students = new Students();
        Classroom classRoom = new Classroom(instructors,students);
        return classRoom;
    }

    @Bean
    @DependsOn({"instructors","previousStudents"})
    public Classroom previousCohort(){
        Instructors instructors = new Instructors();
        Students students = new Students();
        Classroom classroom = new Classroom(instructors,students);
        return classroom;
    }
}
