package com.example.demo;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Primary;

import java.util.ArrayList;

public class InstructorsConfig {

    @Bean
    public Instructors tcUsaInstructors(){
        Instructors dolio = new Instructors(new Instructor(0L, "Dolio"));
        return dolio;
    }

    @Bean
    public Instructors tcUkInstructors(){
        Instructors leon = new Instructors(new Instructor(0L, "Leon"));
        return leon;
    }

    @Bean
    @Primary
    public ArrayList<Instructors> instructors (){
        ArrayList<Instructors> instructors = new ArrayList<>();
        instructors.add(tcUkInstructors());
        instructors.add(tcUsaInstructors());
        return instructors;
    }
}
